Ruby: include/ruby/internal/core/robject.h File Reference

Ruby 3.4.8p72 (2025-12-17 revision 995b59f66677d44767ce9faac6957e5543617ff9)

Data Structures | Macros | Functions
robject.h File Reference

Defines struct RObject. More...

`#include "ruby/internal/config.h"`
`#include "ruby/internal/attr/artificial.h"`
`#include "ruby/internal/attr/deprecated.h"`
`#include "ruby/internal/attr/pure.h"`
`#include "ruby/internal/cast.h"`
`#include "ruby/internal/fl_type.h"`
`#include "ruby/internal/value.h"`
`#include "ruby/internal/value_type.h"`

Go to the source code of this file.

## Data Structures
struct | RObject
| Ruby's ordinal objects. More...

## Macros
#define | ROBJECT(obj)
| Convenient casting macro.

## Functions
static VALUE * | ROBJECT_IVPTR (VALUE obj)
| Queries the instance variables.

## Detailed Description

Defines struct RObject.

Author
  Ruby developers ruby-.nosp@m.core.nosp@m.@ruby.nosp@m.-lan.nosp@m.g.org

Copyright
  This file is a part of the programming language Ruby. Permission is hereby granted, to either redistribute and/or modify this file, provided that the conditions mentioned in the file COPYING are met. Consult the file for details.

Warning
  Symbols prefixed with either RBIMPL or rbimpl are implementation details. Don't take them as canon. They could rapidly appear then vanish. The name (path) of this header file is also an implementation detail. Do not expect it to persist at the place it is now. Developers are free to move it anywhere anytime at will.

Note
  To ruby-core: remember that this header can be possibly recursively included from extension libraries written in C++. Do not expect for instance __VA_ARGS__ is always available. We assume C99 for ruby itself but we don't assume languages of extension libraries. They could be written in C++98.

Definition in file robject.h.

## Macro Definition Documentation

## ◆ ROBJECT

#define ROBJECT | ( |  | obj | ) |

Value:
RBIMPL_CAST((struct RObject *)(obj))
RObject
Ruby's ordinal objects.
Definition robject.h:83

Convenient casting macro.

Parameters

  obj | An object, which is in fact an RObject.

Returns
  The passed object casted to RObject.

Definition at line 43 of file robject.h.

Referenced by ROBJECT_IVPTR().

## Function Documentation

## ◆ ROBJECT_IVPTR()

VALUE * ROBJECT_IVPTR | ( | VALUE | obj | ) |
| inlinestatic

Queries the instance variables.

Parameters

  [in] | obj | Object in question.

Returns
  Its instance variables, in C array.

Precondition
  obj must be an instance of RObject.

Definition at line 136 of file robject.h.

Referenced by ROBJECT_IVPTR().